function IatWebSocket(initWs, action, onConnect, onMessage, onError, url)
{
    this.action = action || 'asr';
    this.url = url || 'ws://realtime.longeplay.cn:8089';
    this.onConnect = onConnect;
    this.onMessage = onMessage;
    this.onError = onError;
    this.index = 1;
    this.pullSn = 1;
    this.sendMuteData = 0;

    if (initWs) {
        this.init();
    }
}

IatWebSocket.prototype.init = function () {
    var _this = this;

    this.ws = new WebSocket(this.url);

    this.ws.onopen = function (ev) {
        clearInterval(_this.reTimer);
        _this.send(JSON.stringify({ task: 'open', uid: _this.uid }));
    };

    this.ws.onmessage = function (ev) {
        var data = JSON.parse(ev.data);

        if (data.task === 'connect') {

            _this.uid = data.uid;

            _this.onConnect();

        }  else if (data.task === 'to') {
            if (_this.type === 'asr' && _this.pullSn !== data.pullSn) return;
            _this.onMessage(data);
        }
    };

    this.ws.onclose = function (ev) 
    {
        console.log(ev);
        clearInterval(_this.pongTimer); 
        _this.index = 1;
        _this.onError();
        _this.reConnect();
    };

    this.ws.onerror = function (ev) {
        console.log(ev);
        _this.onError();       
    };

    if (this.action === 'asr') {
        this.pongTimer = setInterval(function () {
            _this.send(JSON.stringify({ task: 'pong' }));
        }, 50000);
    }
};

IatWebSocket.prototype.send = function (data) {
    if (this.ws && this.ws.readyState === 1) {
        this.ws.send(data);
    }
};

IatWebSocket.prototype.close = function () {
    this.ws.close();
    this.index = 1;
    clearInterval(this.pongTimer);    
};

IatWebSocket.prototype.reConnect = function () {
    if (this.reTimer) return;

    var _this = this;

    this.init();

    this.reTimer = setInterval(function() {

        if (_this.ws.readyState != _this.ws.OPEN) 
            _this.init();
    }, 5000);
};
