/**
 * 机器翻译2.0(niutrans) WebAPI 接口调用示例
 * 运行前：请先填写Appid、APIKey、APISecret
 * 运行方法：直接运行 main() 即可
 * 结果： 控制台输出结果信息
 *
 * 1.接口文档（必看）：https://www.xfyun.cn/doc/nlp/niutrans/API.html
 * 2.错误码链接：https://www.xfyun.cn/document/error-code （错误码code为5位数字）
 * 3.个性化翻译术语自定义：
 * ***登陆开放平台 https://www.xfyun.cn/
 * ***在控制台--机器翻译(niutrans)--自定义翻译处
 * ***上传自定义翻译文件（打开上传或更新窗口，可下载示例文件）
 * @author iflytek
 */

// 系统配置
const config = {
  // 请求地址
  hostUrl: "http://ntrans.xfyun.cn/v2/ots",
  host: "ntrans.xfyun.cn",
  //在控制台-我的应用-机器翻译获取
  appid: "5dc93450",
  //在控制台-我的应用-机器翻译获取
  apiSecret: "a5697605de7def27b8bcbf3392621f9d",
  //在控制台-我的应用-机器翻译获取
  apiKey: "703bec9243073e0d031f07447abaff63",
  uri: "/v2/ots"
}
// 获取当前时间 RFC1123格式
var date = (new Date().toUTCString())


function getPostMsg(transVar)
{
    var postBody = getPostBody(transVar.text, transVar.from, transVar.to);
    var digest = getDigest(postBody);
    var options = {
      url: config.hostUrl,
      headers: {
        'Content-Type': 'application/json',
        'Accept': 'application/json,version=1.0',
        'Host': config.host,
        'Date': date,
        'Digest': digest,
        'Authorization': getAuthStr(date, digest),
        'type':'POST'
      },
      json: true,
      body: postBody
    }

    return options;
}

// 生成请求body
function getPostBody(text, from, to) {
  var digestObj = {
	//填充common
    common: {
      app_id: config.appid
    },
	//填充business
    business:{
      from: from,
      to : to
    },
	//填充data
    data:{
      text: CryptoJS.enc.Base64.stringify(CryptoJS.enc.Utf8.parse(text))
    }
  }
  return digestObj
}

// 请求获取请求体签名
function getDigest(body) 
{
  return 'SHA-256=' + CryptoJS.enc.Base64.stringify(CryptoJS.SHA256(JSON.stringify(body)));
}
// 鉴权签名
function getAuthStr(date, digest) 
{
  var signatureOrigin = 'host: '+ config.host+ '\ndate: '+date+'\nPOST '+config.uri+' HTTP/1.1\ndigest: '+ digest
  var signatureSha = CryptoJS.HmacSHA256(signatureOrigin, config.apiSecret)
  var signature = CryptoJS.enc.Base64.stringify(signatureSha)
  var authorizationOrigin = 'api_key="' + config.apiKey+'", algorithm="hmac-sha256", headers="host date request-line digest", signature="'+ signature;

  return authorizationOrigin;
}
